import java.util.Vector;
import java.util.Collection;
import java.util.Enumeration;
import java.util.Map;

public class Process implements Genable
{
	final boolean DEBUG = false;
	void trace(String s)
	{ if (DEBUG) System.out.println("Process: " + s);}
	
	//represents the process name(consts) = prog
	
	String name;
	
	Vector<String> consts;

	Cmd prog;

	public Process(String name, Vector<String> consts, Cmd prog) {this.name = name; this.consts = consts; this.prog=prog;}
	
	public String genCode(Context c) 
	{ 
		//trace("Process " + name + ": Generating Code");
		String code = name + "(";
		Enumeration<String> e = consts.elements();
		if (e.hasMoreElements())
			code = code + e.nextElement();
		for (; e.hasMoreElements();code = code + "," + e.nextElement() ){}
		//trace("Process " + name + ": Registering Constants");
		c.registerConstants(consts);
		//trace("Process " + name + ": Generating program code");
		code = code + ") = " + prog.genCode(c);
		return code;
	}
	
	public int numArgs() {return consts.size();}
	
	public int numIEs(Map<String,Integer> consts) {return prog.numIEs(consts);}	//these functions return the number of integer and boolean expressions within this Process.  This is the number of seperate expression processes the compiled Expr will generate
	public int numBEs(Map<String,Integer> consts) {return prog.numBEs(consts);}

	public String getIExpr(int i, Map<String, Integer> ivals){return prog.getIExpr(i,ivals);} //returns a string representing the ith integer expression in this
	public String getBExpr(int i, Map<String, Integer> ivals,Map<String,Boolean> bvals){return prog.getBExpr(i,ivals,bvals);}
	
	public String toString()
	{
		String s = name + "(";
		Enumeration<String> e = consts.elements();
		if (e.hasMoreElements())
			s = s + e.nextElement();
		for (; e.hasMoreElements();s = s + "," + e.nextElement() ){}
		return s + ")";
	
	}
}